' Letzte Bearbeitung : 04.04.90 14:25

'

'  B A S I C   -  B I B L I O T H E K   fr die Makrobefehle

'  des SPB-Moduls M-422-2 von SORCUS COMPUTER GmbH

'  Version 1D (Z80-I/O-Befehle)    (nderungen vorbehalten)

DIM siolen%(2)

' Senden eines Zeichen ber M-422-2

SUB ml4tmtsiodat(ferr1%,modul%,kanal%,datbyte%)
LOCAL cmd%
SHARED ml4ferr%

  if (modul% > 0) and (modul% < 5) then
    cmd% = ((modul% - 1) * &H20) + &H80          ' Befehlscode ermitteln
    if kanal% = 0 then
      cmd% = cmd% + 8
    else
      if kanal% = 1 then
        cmd% = cmd% + 9
      end if
    end if
    if ml4ferr% = 0 then call ml4outport(ml4ferr%,cmd%,datbyte%)
    ferr1% = ml4ferr%
  else
    ferr1% = 20
  end if

end SUB

' Status der Schnittstellen der M-422-2

DEF FNml4siostat%(ferr1%,modul%,kanal%)
LOCAL cmd%,stat%
SHARED ml4ferr%

  if (modul% > 0) and (modul% < 5) then
    cmd% = ((modul% - 1) * &H20) + &H80          ' Befehlscode ermitteln
    if kanal% = 0 then
      cmd% = cmd% + 10
    else
      if kanal% = 1 then
        cmd% = cmd% + 11
      end if
    end if
    if ml4ferr% = 0 then call ml4outport(ml4ferr%,cmd%,&H10)
    if ml4ferr% = 0 then call ml4inport(ml4ferr%,stat%,cmd%)
    ferr1% = ml4ferr%
    FNml4siostat% = stat%
  else
    ferr1% = 20
    FNml4siostat% = 0
  end if

end DEF


' Empfangen eines Zeichens ber M-422-2

DEF FNml4rcvsiodat%(ferr1%,modul%,kanal%)
LOCAL cmd%,datbyte%
SHARED ml4ferr%

  if (modul% > 0) and (modul% < 5) then
    cmd% = ((modul% - 1) * &H20) + &H80          ' Befehlscode ermitteln
    if kanal% = 0 then
      cmd% = cmd% + 8
    else
      if kanal% = 1 then
        cmd% = cmd% + 9
      end if
    end if
    if ml4ferr% = 0 then call ml4inport(ml4ferr%,datbyte%,cmd%)
    ferr1% = ml4ferr%
    FNml4rcvsiodat% = datbyte%
  else
    ferr1% = 20
    FNml4rcvsiodat% = 0
  end if

end DEF

' Initialisierung der Schnittstellen auf der M-422-2

SUB ml4initsio(ferr1%,modul%,kanal%,usart%,baud%,dum1%,dum2%)
DIM ctcwerte%(9)
LOCAL cmd%,usartdata%
SHARED ml4ferr%

  if (modul% > 0) and (modul% < 5) then
    cmd% = ((modul% - 1) * &H20) + &H80          ' Befehlscode ermitteln
    if kanal% = 0 then
      cmd% = cmd% + 8
    else
      if kanal% = 1 then
        cmd% = cmd% + 9
      end if
    end if
    if ml4ferr% = 0 then call ml4outport(ml4ferr%,&H79,1)      ' Setzen des Vorteilers /4
    if ml4ferr% = 0 then call ml4outport(ml4ferr%,&H7A,1)      ' Setzen des Teilers /1

    ctcwerte%(0) = 177 : ctcwerte%(1) = 128 : ctcwerte%(2) = 64 : ctcwerte%(3) = 32
    ctcwerte%(4) = 16 : ctcwerte%(5) = 8 : ctcwerte%(6) = 4 : ctcwerte%(7) = 2
    ctcwerte%(8) = 1

    if kanal% = 0 then
      if ml4ferr% = 0 then call ml4outport(ml4ferr%,cmd%+9,&H47)
      if ml4ferr% = 0 then call ml4outport(ml4ferr%,cmd%+9,ctcwerte%(baud%))
      if ml4ferr% = 0 then call ml4outport(ml4ferr%,cmd%+10,&H47)
      if ml4ferr% = 0 then call ml4outport(ml4ferr%,cmd%+10,ctcwerte%(baud%))
    else
      if kanal% = 1 then
        if ml4ferr% = 0 then call ml4outport(ml4ferr%,cmd%+7,&H47)
        if ml4ferr% = 0 then call ml4outport(ml4ferr%,cmd%+7,ctcwerte%(baud%))
      end if
    end if
    if ml4ferr% = 0 then call ml4outport(ml4ferr%,cmd%+2,&H18)
    if (usart% and 4) = 4 then    ' Parity Enable
      if (usart% and 2) = 2 then  ' Parity Even
        usartdata% = 3
      else                        ' Parity Odd
        usartdata% = 1
      end if
    else                          ' Parity Disable
      usartdata% = 0
    end if

    if (usart% and 8) = 8 then
      if (usart% and 16) = 16 then
        usartdata% = usartdata% + &HC   ' 2 Stop Bits
      else
        usartdata% = usartdata% + 4    ' 1 Stop Bit
      end if
    else
      if (usart% and 16) = 16 then
        usartdata% = usartdata% + 8   ' 1 1/2 Stop Bits
      end if
    end if

    usartdata% = usartdata% + &H40
    if ml4ferr% = 0 then call ml4outport(ml4ferr%,cmd%+2,&H14)
    if ml4ferr% = 0 then call ml4outport(ml4ferr%,cmd%+2,usartdata%)

    if (usart% and 32) = 32 then
      if (usart% and 64) = 64 then
        usartdata% = 0
      else
        usartdata% = &H20
      end if
    else
      if (usart% and 64) = 64 then
        usartdata% = &H40
      else
        usartdata% = &H60
      end if
    end if

    if ml4ferr% = 0 then call ml4outport(ml4ferr%,cmd%+2,&H15)
    if ml4ferr% = 0 then call ml4outport(ml4ferr%,cmd%+2,usartdata%+&HA)

    siolen%(kanal%) = usartdata% + 8 ' wird fr RTS bentigt

    usartdata% = usartdata% * 2
    if ml4ferr% = 0 then call ml4outport(ml4ferr%,cmd%+2,&H13)
    if ml4ferr% = 0 then call ml4outport(ml4ferr%,cmd%+2,usartdata%+1)
    ferr1% = ml4ferr%
  else
    ferr1% = 20
  end if

end SUB

' Setzen desr RTS-Bits

SUB ml4setrts(ferr1%,modul%,kanal%)
LOCAL cmd%

  if (modul% > 0) and (modul% < 5) then
    cmd% = ((modul% - 1) * &H20) + &H80          ' Befehlscode ermitteln
    if kanal% = 0 then
      cmd% = cmd% + 8
    else
      if kanal% = 1 then
        cmd% = cmd% + 9
      end if
    end if
    if ml4ferr% = 0 then call ml4outport(ml4ferr%,cmd%+2,&H15)
    siolen%(kanal%) = siolen(kanal%) or 2
    if ml4ferr% = 0 then call ml4outport(ml4ferr%,cmd%+2,siolen%(kanal%))
    ferr1% = ml4ferr%
  else
    ferr1% = 20
  end if

end SUB

' Lschen des RTS-Bits

SUB ml4clrrts(ferr1%,modul%,kanal%)
LOCAL cmd%
SHARED ml4ferr%

  if (modul% > 0) and (modul% < 5) then
    cmd% = ((modul% - 1) * &H20) + &H80          ' Befehlscode ermitteln
    if kanal% = 0 then
      cmd% = cmd% + 8
    else
      if kanal% = 1 then
        cmd% = cmd% + 9
      end if
    end if
    if ml4ferr% = 0 then call ml4outport(ml4ferr%,cmd%+2,&H15)
    siolen%(kanal%) = siolen(kanal%) and &HFD
    if ml4ferr% = 0 then call ml4outport(ml4ferr%,cmd%+2,siolen%(kanal%))
    ferr1% = ml4ferr%
  else
    ferr1% = 20
  end if

end SUB

' Setzen des DTR-Bits

SUB ml4setdtr(ferr1%,modul%,kanal%)
LOCAL cmd%

  if (modul% > 0) and (modul% < 5) then
    cmd% = ((modul% - 1) * &H20) + &H80          ' Befehlscode ermitteln
    if kanal% = 0 then
      cmd% = cmd% + 8
    else
      if kanal% = 1 then
        cmd% = cmd% + 9
      end if
    end if
    if ml4ferr% = 0 then call ml4outport(ml4ferr%,cmd%+2,&H15)
    siolen%(kanal%) = siolen(kanal%) or &H80
    if ml4ferr% = 0 then call ml4outport(ml4ferr%,cmd%+2,siolen%(kanal%))
    ferr1% = ml4ferr%
  else
    ferr1% = 20
  end if

end SUB

' Lschen des DTR-Bits

SUB ml4clrdtr(ferr1%,modul%,kanal%)
LOCAL cmd%
SHARED ml4ferr%

  if (modul% > 0) and (modul% < 5) then
    cmd% = ((modul% - 1) * &H20) + &H80          ' Befehlscode ermitteln
    if kanal% = 0 then
      cmd% = cmd% + 8
    else
      if kanal% = 1 then
        cmd% = cmd% + 9
      end if
    end if
    if ml4ferr% = 0 then call ml4outport(ml4ferr%,cmd%+2,&H15)
    siolen%(kanal%) = siolen(kanal%) and &H7F
    if ml4ferr% = 0 then call ml4outport(ml4ferr%,cmd%+2,siolen%(kanal%))
    ferr1% = ml4ferr%
  else
    ferr1% = 20
  end if

end SUB
